#include "memory_manager.h"

// **************************************************************************************
// User-defined memory manager, which maintains a pool of transactions
// **************************************************************************************


MemoryManager::gp_t* MemoryManager::allocate() {
  gp_t* ptr;
  if (free_list) {
    ptr = free_list->trans;
    empties = free_list;
    free_list = free_list->next;
  }
  else {
    ptr = new gp_t(this);
  }
  return ptr;
}

void MemoryManager::free(gp_t* trans)
{
  if (!empties) {
    empties = new access;
    empties->next = free_list;
    empties->prev = 0;
    if (free_list)
      free_list->prev = empties;
  }
  free_list = empties;
  free_list->trans = trans;
  empties = free_list->prev;
}

// Generate a random delay (with power-law distribution) to aid testing and stress the protocol
int rand_ps() {
  int n = rand() % 100;
  n = n * n * n;
  return n / 100;
}
