/*******************************************************************************
 * Copyright (C) 2024 Juan Neyra
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 ******************************************************************************/
#pragma once

#include <systemc>
#include "configuration.h"
#include "utils.h"

#define DEF_LOGFILENAME "./out/report.log"

#define N_LOGFILENAME   "./out/noc_conn.log"
#define N_LOG           "TLM_NOC"

#define R_LOGFILENAME   "./out/noc_transactions.log"
#define R_LOG           "TLM_ROUTER"

#define NI_LOGFILENAME   "./out/ni.log"
#define NI_LOG           "TLM_NI"

#define NM_LOGFILENAME "./out/nm_conn.log"
#define NM_LOG "NetworkManager"

#define PE_LOGFILENAME "./out/pe_tasks.log"
#define PE_LOG "ProcessingElement"

#define ASCII_RED       "31"
#define ASCII_GREEN     "32"
#define ASCII_YELLOW    "33"

const std::string str_dir[Direction::num_dirs] = {"local","east","west","north","south","up","down"};

/** 
 * Handles log messages (writes to console and log)
 *
 * @param report    report object with log information
 * @param actions   valid actions
 */
void report_handler(const sc_report& report, const sc_actions& actions);

/** 
 * Configure sc report handler filename and actions
 */
void setup_logger();

//void creds_log_info(std::string router_name, uint8_t link, uint8_t num_creds, bool is_ext);

/** 
 * Log to cout
 */
void cout_logger(std::string msg);
